// B5_JUMP  961025 - Created for the ray-trace competision at www.povray.org
//
// Copyright David Eliasson 1996
// Comments to David@cebec.arosnet.se

#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"

#declare gop=
      cylinder { <0,0,10> <0,0,999> 24 open texture { pigment { spiral1 7 turbulence 0.6 scale 15 rotate <90,90,90> color_map
                 {
                   [0.0, 0.2 color rgbt <0.0, 0.8, 0.1, -1> color rgbt <0.0, 0.9, 0.1, -1>]
                   [0.2, 0.3 color rgbt <0.0, 0.7, 0.1, 0> color rgbt <0.0, 0.8, 0.1, 0>]
                   [0.3, 0.4 color rgbt <0.0, 0.5, 0.0, 0.1> color rgbt <0.0, 0.6, 0.1, 0.3>]
                   [0.4, 0.5 color rgbt <0.0, 0.2, 0.0, 0.3> color rgbt <0.0, 0.4, 0.2, 0.5>]
                   [0.5, 1.0 color rgbt <0.0, 0.0, 0.0, 0.9> color rgbt <0.0, 0.0, 0.0, 1.0>]
                 } } finish { specular 1 roughness 0.001 ambient 0.40 diffuse 0.4 reflection 0.5 refraction 0 ior 1 } }
               }



#declare sw=
  union
    {
      polygon { 5 , <-2,0,-0.5>,<-2,0,0.5>,<2,0,0.5>,<2,0,-0.5>,<-2,0,-0.5> texture { pigment { Gray30 } finish { Metal } } }
      polygon { 4 , <3,-0.01,-5>,<1,-0.01,-1.5>,<1,-0.01,1.5>,<3,-0.01,-5> texture { pigment { White } finish { Metal } } }
      polygon { 4 , <3,-0.01,5>,<1,-0.01,1.5>,<3,-0.01,-5>,<3,-0.01,5> texture { pigment { White } finish { Metal } } }
      polygon { 5 , <3,-0.01,-5>,<3,-0.01,5>,<8,-4,1.5>,<8,-4,-1.5>,<3,-0.01,-5> texture { pigment { White } finish { Metal } } }
      polygon { 4 , <-3,-0.01,-5>,<-1,-0.01,-1.5>,<-1,-0.01,1.5>,<-3,-0.01,-5> texture { pigment { White } finish { Metal } } }
      polygon { 4 , <-3,-0.01,5>,<-1,-0.01,1.5>,<-3,-0.01,-5>,<-3,-0.01,5> texture { pigment { White } finish { Metal } } }
      polygon { 5 , <-3,-0.01,-5>,<-3,-0.01,5>,<-8,-4,1.5>,<-8,-4,-1.5>,<-3,-0.01,-5> texture { pigment { White } finish { Metal } } }
      light_source { <0,-0.2,-15> color White looks_like { sphere {<0,0,0>,0.5 texture { pigment { White } } } } fade_distance 3 fade_power 1.8}
      light_source { <0,-0.2,-16> color White looks_like { sphere {<0,0,0>,0.5 texture { pigment { White } } } } fade_distance 3 fade_power 1.8}
      light_source { <0,-0.2,-17> color White looks_like { sphere {<0,0,0>,0.5 texture { pigment { White } } } } fade_distance 3 fade_power 1.8}
      light_source { <0,-0.2,-18> color White looks_like { sphere {<0,0,0>,0.5 texture { pigment { White } } } } fade_distance 3 fade_power 1.8}
      light_source { <0,-0.2,-19> color White looks_like { sphere {<0,0,0>,0.5 texture { pigment { White } } } } fade_distance 3 fade_power 1.8}
    }


#declare gate=
  union
    {
      box { <-0.5,30,-20> <0.5,31,600> texture { pigment{ Gray20 } finish { Metal } } }
      box { <30,-0.5,-20> <31,0.5,600> texture { pigment{ Gray20 } finish { Metal } } }
      box { <-0.5,-30,-20> <0.5,-31,600> texture { pigment{ Gray20 } finish { Metal } } }
      box { <-31,-0.5,-20> <-30,0.5,600> texture { pigment{ Gray20 } finish { Metal } } }
      cylinder { <-0.5,30,-20> <-0.5,30,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <0.5,30,-20> <0.5,30,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <-0.5,31,-20> <-0.5,31,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <0.5,31,-20> <0.5,31,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <-0.5,-30,-20> <-0.5,-30,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <0.5,-30,-20> <0.5,-30,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <-0.5,-31,-20> <-0.5,-31,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <0.5,-31,-20> <0.5,-31,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }

      cylinder { <30,-0.5,-20> <30,-0.5,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <30,0.5,-20> <30,0.5,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <31,-0.5,-20> <31,-0.5,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <31,0.5,-20> <31,0.5,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <-30,-0.5,-20> <-30,-0.5,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <-30,0.5,-20> <-30,0.5,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <-31,-0.5,-20> <-31,-0.5,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }
      cylinder { <-31,0.5,-20> <-31,0.5,600> 0.1 open texture { pigment{ color rgb <0.6 0.6 0.8> } finish { Metal } } }

      object { sw translate <0,30,0> }
      object { sw translate <0,30,50> }
      object { sw translate <0,30,100> }
      object { sw translate <0,30,150> }
      object { sw translate <0,30,200> }
      object { sw translate <0,30,250> }
      object { sw translate <0,30,300> }
      object { sw translate <0,30,350> }

      object { sw translate <0,30,0> rotate <0,0,90> }
      object { sw translate <0,30,50> rotate <0,0,90> }
      object { sw translate <0,30,100> rotate <0,0,90> }
      object { sw translate <0,30,150> rotate <0,0,90> }
      object { sw translate <0,30,200> rotate <0,0,90> }
      object { sw translate <0,30,250> rotate <0,0,90> }
      object { sw translate <0,30,300> rotate <0,0,90> }
      object { sw translate <0,30,350> rotate <0,0,90> }

      object { sw translate <0,30,0> rotate <0,0,180> }
      object { sw translate <0,30,50> rotate <0,0,180> }
      object { sw translate <0,30,100> rotate <0,0,180> }
      object { sw translate <0,30,150> rotate <0,0,180> }
      object { sw translate <0,30,200> rotate <0,0,180> }
      object { sw translate <0,30,250> rotate <0,0,180> }
      object { sw translate <0,30,300> rotate <0,0,180> }
      object { sw translate <0,30,350> rotate <0,0,180> }

      object { sw translate <0,30,0> rotate <0,0,270> }
      object { sw translate <0,30,50> rotate <0,0,270> }
      object { sw translate <0,30,100> rotate <0,0,270> }
      object { sw translate <0,30,150> rotate <0,0,270> }
      object { sw translate <0,30,200> rotate <0,0,270> }
      object { sw translate <0,30,250> rotate <0,0,270> }
      object { sw translate <0,30,300> rotate <0,0,270> }
      object { sw translate <0,30,350> rotate <0,0,270> }

      light_source { <0,0,0> color Green looks_like { object {gop} } fade_distance 20 fade_power 2 }

    }

