// B5_JUMP  961025 - Created for the ray-trace competision at www.povray.org
//
// Copyright David Eliasson 1996
// Comments to David@cebec.arosnet.se

#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"

#declare nebu=
sphere { 0, 1
  pigment { color rgbt <1, 1, 1, 1> }
  halo {
    emitting
    spherical_mapping
    linear
    turbulence 1.5
    color_map {
      [ 0 color rgbt <.4,0,0.8,0.5> ]
      [ 1 color rgbt <.2,0,0.8,-1.0> ]
    }
    frequency 2
    samples 20
    scale 0.5
  }
  hollow
  scale 1.5
}

#declare space=
  union
    {
      // Planet
      sphere { <-800,0,-300>,100 texture { pigment { granite turbulence 0.1
        color_map {
        [0.0, 0.3 color rgb <0.6, 0.3, 0.3> color rgb <1.0, 0.5, 0.5>]
        [0.3, 1.0 color rgb <0.9, 0.0, 0.0> color rgb <1.0, 0.2, 0.2>]
                  }
               } }
             }

      // Fare space
      object { nebu scale 100 translate <-240,-60,1000> }
      object { nebu scale 80 translate <1000,20,0> }

      // Rim
      sphere
          { <0,0,0>,1000 texture
            { pigment
              { granite color_map
                {
                  [ 0.00  0.35 color Black  color Black ]
                  [ 0.35  0.351 color Gray20 color Gray40 ]
                  [ 0.351  0.3515 color Gray80 color White ]
                  [ 0.3515  0.85 color Black color Black ]
                  [ 0.85  0.851 color Gray20 color Gray40 ]
                  [ 0.851  0.852 color Gray60 color Gray80 ]
                  [ 0.852  0.853 color Gray40 color Gray60 ]
                  [ 0.853  1.00 color Black color Black ]
                }
              } finish { ambient 1 diffuse 0 }
            } hollow
          }
}
